
/*
 * _ansi.h - some ANSI related defines
 * Copyright (c) 2003, The LusitanOS Project. All rights reserved.
 *
 * maintainer(s): hybrid-2k
 * started: 2003-06-25
 * changed: 2003-06-25
 *
 * This program is free software, and you can redistribute it and/or modify it
 * under the terms of the LSD (Lusitan Source Distribution) License, which are
 * described in the following text.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files, to deal them without
 * restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of it, and to
 * permit persons to whom it is furnished to do so, subject to the following
 * conditions:
 * - The above copyright notice and this permission notice shall be included
 *  in all copies or portions of this software.
 * - The source code and documentation of this software shall be included
 *  along with all binary distributions and any other kind of product that
 *  uses this software or substantial portions from it.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#ifndef __ANSI_H_
#define __ANSI_H_

/* compiler is totaly ANSI conformant */
#ifdef __STDC__
#define _ANSI
#endif

/* GCC should be quite compatible with ANSI */
#ifdef __GNUC__
#define _ANSI
#endif

#ifdef _ANSI
#define _AND ,
#define _CAST_VOID (void)
#define _CONST const
#define _CONST const
#define _DEFUN(name, arglist, args) name(args)
#define _DEFUN_VOID(name) name(_NOARGS)
#define _DOTS , ...
#define _EXFUN(name, proto) name proto
#define _EXPARM(name, proto) (* name) proto
#define _LONG_DOUBLE long double
#define _NOARGS void
#define _PARAMS(paramlist) paramlist
#define _PTR void *
#define _SIGNED signed
#define _VOID void
#define _VOLATILE volatile
#define _VOLATILE volatile
#else
#define _AND ;
#define _CAST_VOID
#define _CONST
#define _CONST
#define _DEFUN(name, arglist, args) name arglist args;
#define _DEFUN_VOID(name) name()
#define _DOTS
#define _EXFUN(name, proto) name()
#define _LONG_DOUBLE double
#define _NOARGS
#define _PARAMS(paramlist) ()
#define _PTR char *
#define _SIGNED
#define _VOID void
#define _VOLATILE
#define _VOLATILE
#endif

#endif /* ! __ANSI_H_ */
