
/*
 * types.h - system types (mostly i386 specific)
 * Copyright (c) 2003, The LusitanOS Project. All rights reserved.
 *
 * maintainer(s): hybrid-2k
 * started: 2003-06-18
 * changed: 2003-06-25
 *
 * This program is free software, and you can redistribute it and/or modify it
 * under the terms of the LSD (Lusitan Source Distribution) License, which are
 * described in the following text.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files, to deal them without
 * restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of it, and to
 * permit persons to whom it is furnished to do so, subject to the following
 * conditions:
 *  - The above copyright notice and this permission notice shall be included
 *    in all copies or portions of this software.
 *  - The source code and documentation of this software shall be included
 *    along with all binary distributions and any other kind of product that
 *    uses this software or substantial portions from it.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#ifndef	_SYS_TYPES_H_
#define _SYS_TYPES_H_

#include <_ansi.h>
#include <sys/_types.h>

/* Base types */
typedef __signed char   __int8_t;
typedef unsigned char   __uint8_t;
typedef signed short    __int16_t;
typedef unsigned short  __uint16_t;
typedef signed long     __int32_t;
typedef unsigned long   __uint32_t;
typedef float           __float_t;
typedef double          __double_t;

#if defined(lint)
typedef long long __int64_t;
typedef unsigned long long __uint64_t;
#elif defined(__GNUC__)
typedef int __attribute__ ((__mode__(__DI__))) __int64_t;
typedef unsigned int __attribute__ ((__mode__(__DI__))) __uint64_t;
#else
typedef long long __int64_t;
typedef unsigned long long __uint64_t;
#endif


/* Standard type definitions */
typedef __uint32_t  __clock_t;
typedef __int32_t   __critical_t;

typedef __int32_t   __intfptr_t;
typedef __int64_t   __intmax_t;
typedef __int32_t   __intptr_t;
typedef __int32_t   __int_fast8_t;
typedef __int32_t   __int_fast16_t;
typedef __int32_t   __int_fast32_t;
typedef __int64_t   __int_fast64_t;
typedef __int8_t    __int_least8_t;
typedef __int16_t   __int_least16_t;
typedef __int32_t   __int_least32_t;
typedef __int64_t   __int_least64_t;
typedef __int32_t   __ptrdiff_t;
typedef __int32_t   __register_t;
typedef __int32_t   __segsz_t;
typedef __uint32_t  __size_t;
typedef __int32_t   __ssize_t;
typedef __int32_t   __time_t;
typedef __uint32_t  __uintfptr_t;
typedef __uint64_t  __uintmax_t;
typedef __uint32_t  __uintptr_t;
typedef __uint32_t  __uint_fast8_t;
typedef __uint32_t  __uint_fast16_t;
typedef __uint32_t  __uint_fast32_t;
typedef __uint64_t  __uint_fast64_t;
typedef __uint8_t   __uint_least8_t;
typedef __uint16_t  __uint_least16_t;
typedef __uint32_t  __uint_least32_t;
typedef __uint64_t  __uint_least64_t;
typedef __uint32_t  __u_register_t;
typedef __uint32_t  __vm_offset_t;
typedef __int64_t   __vm_ooffset_t;
typedef __uint64_t  __vm_pindex_t;
typedef __uint32_t  __vm_size_t;


/* Useful type definitions */
typedef __int32_t   __clockid_t;
typedef __uint32_t  __fflags_t;
typedef __uint64_t  __fsblkcnt_t;
typedef __uint64_t  __fsfilcnt_t;
typedef __uint32_t  __gid_t;
typedef __int64_t   __id_t;
typedef __uint32_t  __ino_t;
typedef __int32_t   __key_t;
typedef __uint16_t  __mode_t;
typedef __int32_t   __nl_item;
typedef __uint16_t  __nlink_t;
typedef __int64_t   __off_t;
typedef __int32_t   __pid_t;
typedef __int64_t   __rlim_t;
typedef __uint32_t  __socklen_t;
typedef __int32_t   __suseconds_t;
typedef __int32_t   __timer_t;
typedef __uint32_t  __uid_t;
typedef __uint32_t  __useconds_t;
typedef __uint8_t   __sa_family_t;


/* va_list type definitions */
#if defined(__GNUC__) && (__GNUC__ == 2 && __GNUC_MINOR__ > 95 || __GNUC__ >= 3)
typedef __builtin_va_list__va_list; /* internally known to gcc */
#else
typedefchar *__va_list;
#endif /* post GCC 2.95 */
#if defined __GNUC__ && !defined(__GNUC_VA_LIST) && !defined(__NO_GNUC_VA_LIST)
#define __GNUC_VA_LIST
typedef __va_list__gnuc_va_list; /* compatibility w/GNU headers */
#endif

#endif /* ! _SYS_TYPES_H_ */
